// Keep track of the current order number
let currentOrder = 0;

jQuery(function($){
    $('body').append(`
            <div id="plai-box">
                <div class="top-actions">
                    <h2>Plugna - Login AI<span></span></h2>
                    <button id="plai-go-back" class="back">❌ Exit </button>
                </div>
                <textarea id="plai-css-box" placeholder='Write your request here and hit enter, for example: \n\n"set the background color of the page to blue"'></textarea>
                <div id="plai-error-box">
                    <p></p>
                </div>
                <div id="saved-styles">
                    <input id="saved-styles-toggle" type="checkbox" checked="checked">
                    <label id="saved-styles-toggle-label" for="saved-styles-toggle"><b>SAVED STYLES</b></label>
                    <button class="edit">Edit</button>
                </div>
                <ul id="plai-css-history-list" class="plai-css-history-list"></ul>
                <div id="plai-css-history-stack" class="plai-css-history-stack" style="bottom: 120px;"></div>
                <div id="plai-bottom-actions">
                    <button id="plai-publish" class="save">Publish selected styles</button>
                </div>
            </div>
    `);

    const $cssBox = $('#plai-css-box');
    //const $applyBtn = $('#plai-apply-btn');
    const $historyStack = $('.plai-css-history-stack');
    const $historyList = $('.plai-css-history-list');
    let prevPrompts = $('#plugnalai-previous-prompts').text();
    const $savedStylesEdit = $('#saved-styles button.edit');
    const $savedStylesToggle = $('#saved-styles-toggle');

    $savedStylesEdit.on('click', function(){
         ajaxSavedStylesEdit();
    });

    $savedStylesToggle.on('change', function(){
        //toggle style on/off that contains in url "plugnalai_css"
        const $this = $(this);
        const checked = $this.is(':checked');
        const $style = $('#plugnalai-css');

        //first time set data
        if(!$style.data('href')){
            $style.data('href', $style.attr('href'));
        }

        if(checked){
            $style.attr('href', $style.data('href'));
        }else {
            $style.attr('href', '');
        }
    });

    $historyList.on('change', 'input[type=checkbox]', function() {
        const $this = $(this);
        //const name =$this.find('span.name').text();
        //const css = $this.find('span.css').text();
        const id = $this.parent().data('id');

        // Get the existing style tag for this submission
        const style = document.querySelector(`style[data-id="plai-css-${id}"]`);

        if ($this.is(':checked')) {
            //checked
            if (style) {
                style.textContent = style.textContent.substring(2, style.textContent.length - 2);
            }
        }else{
            // If the checkbox is unchecked, comment out the existing style tag
            if (style) {
                style.textContent = `/*${style.textContent}*/`;
            }
        }

    })
        .on('click', 'button.like-style', function() {
            const $li = $(this).parent().parent().parent();
            ajaxLikeStyle($li);
        })
        .on('click', 'button.dislike-style', function() {
            const $li = $(this).parent().parent().parent();
            ajaxLikeStyle($li, false);
        })
        .on('click', 'button.remove-style', function() {
            const $li = $(this).parent().parent().parent();
            const id = $li.data('id');

            ajaxRemoveStyle(id, function(){
                //remove style from head
                jQuery(`[data-id=plai-css-${id}]`).remove();

                //remove li
                $li.remove();
            });

        });
    $('#plai-publish').on('click', function() {
        ajaxPublishStyles();
    })

    $('#plai-go-back').on('click', function() {
        window.location.href= '/wp-admin/tools.php?page=plugna-login-ai';
    });

    const nl2br = function(str, is_xhtml) {
        var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
        return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1'+ breakTag +'$2');
    }

    const showPlaiError = function(message){
        if(!message){
            message = 'Unknown error';
        }
        jQuery('#plai-error-box p').html(nl2br(message));
        jQuery('#plai-error-box').show();
    }

    const hidePlaiError = function(){
        jQuery('#plai-error-box').hide();
    }

    const ajaxRemoveStyle = function(id, callback){

        hidePlaiError();
        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_remove_style',
                id: id
            },
            success: function( response ) {
                if ( response.success ) {
                    console.log( 'Style removed successfully' );
                    //processCss(response.message);
                    //console.log(response.message);
                    callback();
                } else {
                    showPlaiError(response.message);
                    //TODO: Process errors and show on page
                    //console.log( 'Error: ' + response.message );
                }
            },
            // complete: function() {
            //     $li.addClass('voted');
            //     console.log('complete');
            // },
            error: function( xhr, status, error ) {
                showPlaiError(error);
                console.log( 'Error: ' + error );
            }
        });
    }

    const checkAvailableCredits = function(){
        hidePlaiError();
        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_check_credits',
            },
            success: function(response) {
                console.log(response, response.m);
                if (response.success) {
                    refreshCredits(response.message);
                }else{
                    showPlaiError(response.message);
                }
            },
            // error: function(jqXHR, textStatus, errorThrown) {
            //     // Handle the error response
            //     alert(plugnaAilAjax.error);
            //     console.log(jqXHR, textStatus);
            //     //console.log(plugnaAilAjax.error.error);
            // },
        });
    }

    const ajaxSavedStylesEdit = function(){

        hidePlaiError();
        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_edit_saved_styles',
            },
            success: function( response ) {
                if ( response.success ) {
                    window.location.reload();
                }else{
                    showPlaiError(response.message);
                }
            },
            // complete: function() {
            //     $li.addClass('voted');
            //     console.log('complete');
            // },
            error: function( xhr, status, error ) {
                showPlaiError(error);
                console.log( 'Error: ' + error );
            }
        });
    }

    const refreshCredits = function (credits){
        if(typeof credits !== 'number'){
            return;
        }
        jQuery('.top-actions h2 > span').text('(' + credits + ' credits)')
    }

    const ajaxLikeStyle = function($li, like = true) {
        hidePlaiError();
        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_like_style',
                like: like,
                id: $li.data('id')
            },
            success: function( response ) {
                if ( response.success ) {
                    console.log( 'Text message received successfully' );
                    //processCss(response.message);
                    console.log(response.credits);
                    refreshCredits(response.credits)
                } else {
                    showPlaiError(response.message);
                    console.log( 'Error: ' + response.message );
                }
            },
            complete: function() {
                $li.addClass('voted');
                console.log('complete');
            },
            error: function( xhr, status, error ) {
                showPlaiError(error);
                console.log( 'Error: ' + error );
            }
        });
    }

    const ajaxPublishStyles = function() {

        let ids = [];
        hidePlaiError();
        jQuery('#plai-css-history-list li input:checked').each(function(){
            ids.push(jQuery(this).parent().data('id'))
        });

        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_publish_styles',
                ids: ids,
                old_styles_included: jQuery('#saved-styles-toggle').is(':checked')
            },
            success: function( response ) {

                window.location.reload();
                // if ( response.success ) {
                //     console.log( 'Text message received successfully' );
                //     //processCss(response.message);
                //
                //     console.log(response.message);
                // } else {
                //     //TODO: Process errors and show on page
                //     //console.log( 'Error: ' + response.message );
                // }
            },
            // complete: function() {
            //     $li.addClass('voted');
            //     console.log('complete');
            //     alert('ajax not done yet')
            // },
            error: function( xhr, status, error ) {
                showPlaiError(error);
                console.log( 'Error: ' + error );
            }
        });
    }

    const plaiAjaxCall = function(id){
        hidePlaiError();
        const text = $cssBox.val().trim();

        $cssBox.addClass('disabled');
        //console.log('text', text);
        //return;
        jQuery.ajax({
            url: SLAjax.ajax_url,
            type: 'POST',
            dataType: 'json',
            data: {
                action: 'plugnalai_prompt',
                text: text,
                id: id
            },
            success: function( response ) {
                if ( response.success ) {
                    console.log( 'Text message received successfully' );
                    processCss(response.message);
                    console.log(response.message);
                    refreshCredits(response.credits)
                } else {
                    showPlaiError(response.message);
                    //TODO: Process errors and show on page
                    //console.log( 'Error: ' + response.message );
                }
            },
            complete: function() {
                $cssBox.removeClass('disabled');
                $cssBox.val('');
            },
            error: function( xhr, status, error ) {
                showPlaiError(error);
                console.log( 'Error: ' + error );
            }
        });
    };

    const processCss = function(css) {
        //const css = cssBox.value.trim();
        if (css !== '') {
            // Increment the order number
            currentOrder++;

            $historyList.append(
                `<li data-id="${currentOrder}">
                    <input title="Click to toggle visibility of the style" type="checkbox" checked="checked">
                    <label title="${$cssBox.val()}\n---\n${css}"><b>#${currentOrder}</b>&nbsp;${$cssBox.val()}</label>
                    <span class="name">${$cssBox.val()}</span>
                    <span class="css">${css}</span>
                    <ul class="actions">
                        <li class="vote"><button class="like-style" title="Give us feedback that this worked as expected, so we can improve the model">👍</button></li>
                        <li class="vote"><button class="dislike-style" title="Give us feedback this this didn't worked as you expected">👎</button></li>
                        <li><button class="remove-style" title="Delete this style if you don't want to keep it">❌</button></li>
                    </ul>
                 </li>`
            ).show();


            const cssName = `plai-css-${currentOrder}`;
            // Save the CSS to the page
            const style = document.createElement('style');
            style.textContent = css;
            style.dataset.id = cssName;
            document.getElementById('plugnalai-styles-container').appendChild(style);

            // Clear the textarea for the next input
            $cssBox.val('');
        }
    }

    // apply previous prompts on page load
    if(prevPrompts.length){
        prevPrompts = JSON.parse(prevPrompts);
        prevPrompts.prompts && Object.keys(prevPrompts.prompts).forEach(function(key) {
            const prompt = prevPrompts.prompts[key];
            $cssBox.val(prompt.question);
            processCss(prompt.answer);
            //console.log();
        });

        $('#plai-css-history-list li').addClass('voted');

        if(!prevPrompts.css) {
            $('#saved-styles').hide()
            $('#plugnalai-css').remove();
        }

        if(prevPrompts.credits) { //if saved previous credits in DB, show them
            refreshCredits(prevPrompts.credits)
        }else{//else if not available, check for available credits
            checkAvailableCredits();
        }
    }

    $cssBox.keydown(function(e) {
        if (e.keyCode === 13) { // Check if "Enter" key was pressed
            plaiAjaxCall(currentOrder + 1); // Call your function here
            e.preventDefault(); // Prevent default behavior of "Enter" key
        }
    });

    // Add event listener to the window resize event to adjust the position of the CSS history stack
    window.addEventListener('resize', function() {
        const windowHeight = window.innerHeight;
        const cssHistoryListBottom = $historyList.get(0).getBoundingClientRect().bottom;
        if (cssHistoryListBottom > windowHeight) {
            $historyStack.get(0).style.bottom = `${cssHistoryListBottom - windowHeight + 120}px`;
        } else {
            $historyStack.get(0).style.bottom = '120px';
        }
    });

// Add event listener to the window scroll event to adjust the position of the CSS history stack
    window.addEventListener('scroll', function() {
        const windowHeight = window.innerHeight;
        const cssHistoryListBottom = $historyList.get(0).getBoundingClientRect().bottom;
        if (cssHistoryListBottom > windowHeight) {
            $historyStack.get(0).style.bottom = `${cssHistoryListBottom - windowHeight + 120}px`;
        } else {
            $historyStack.get(0).style.bottom = '120px';
        }
    });

// Add event listener to the window load event to adjust the position of the CSS history stack
    window.addEventListener('load', function() {
        const windowHeight = window.innerHeight;
        const cssHistoryListBottom = $historyList.get(0).getBoundingClientRect().bottom;
        if (cssHistoryListBottom > windowHeight) {
            $historyStack.get(0).style.bottom = `${cssHistoryListBottom - windowHeight + 120}px`;
        } else {
            $historyStack.get(0).style.bottom = '120px';
        }
    });
});