<?php

namespace PlugnaLAI;

class PlugnaLAI_Helpers
{

    public function is_plugna_context_login_page(){
        return isset($_GET['context']) && $_GET['context'] === 'plugna-login-ai';
    }

    public function does_text_contains_any_substring($text, $substrings = array()) {
        foreach ((array) $substrings as $substring) {
            if (strpos($text, $substring) !== false) {
                return true;
            }
        }
        return false;
    }

    public function does_user_has_access()
    {
        return is_user_logged_in() && current_user_can('manage_options');
    }

    public function check_access()
    {
        if (!$this->does_user_has_access()) {
            wp_send_json_error('You must be logged in as an administrator to register this plugin.');
            die;
        }
    }

}