    <div class="wrap plugna-wrap">
        <h1>Plugna Login AI - Settings</h1>
        <table class="plai-notifications">
            <tr id="plugna-ai-error">
                <th colspan="2">Error</th>
            </tr>
            <tr id="plugna-ai-success">
                <th colspan="2">Submitted. Please check your email to verify.</th>
            </tr>
        </table>
        <form method="post" action="options.php">
            <?php settings_fields('plugna_ail'); ?>
            <?php do_settings_sections('plugna_ail'); ?>
            <table class="form-table">

                <tr valign="top">
                    <th scope="row">Email</th>
                    <td>
                        <input
                                style="width: 100%; max-width: 400px;"
                                type="email"
                                name="plugna_ail_email"
                                id="plugna-ail-email"
                                value="<?php echo esc_attr(get_option('plugnalai_email')); ?>"
                                required
                        />
<!--                        <button type="button" id="get-api-key">Get API Key</button>-->
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">OpenAI Key (or <a href="https://plugna.com/login-ai/" target="_blank">License Key</a>)</th>
                    <td><input
                                style="width: 100%; max-width: 400px;"
                                type="text"
                                placeholder="OpenAI API key or PLAI License Key"
                                name="plugna_ail_openai_key"
                                id="plugna-ail-openai-key"
                                value=""
                                required
                        /><br>
                        <i>You need to have an OpenAI API key or PLAI License Key. <br><br>- Get the OpenAI key here: <a href="https://platform.openai.com/account/api-keys" target="_blank">Get an OpenAI Key</a></i><br>
                        <i>- To get a PLAI License Key, please <a href="https://plugna.com/login-ai/" target="_blank">purchase any PLAI package</a> </i>
                        </p>

                    </td>
                </tr>
                <tr>
                    <th></th>
                    <td>
                        <p>By registering you agree with our <a href="https://plugna.com/login-ai/terms" target="_blank">terms</a> and <a href="https://plugna.com/login-ai/privacy" target="_blank">privacy policy</a> </p>
                    </td>
                </tr>
                <tr>
                    <th></th>
                    <td>
                        <?php submit_button('Register', 'primary', 'register-plugin', false, array(
                                'style' => 'width: 100%; max-width: 400px;',
                        )); ?>
                    </td>
                </tr>
            </table>

        </form>
        <div class="plugnalai-pending-verification">
            <h2>Pending email verification</h2>
            <p>Thank you! Please check your email to verify your account</p>
            <p>After you click on the confirmation link in your email, click the button bellow to finalize registration</p>
            <?php submit_button('Finalize registration', 'primary', 'finalize-registration', false, array(
                'onclick' => 'finalizeRegistration()',
                'title' => 'Once you verify your site via email, click this button to finalize the registration',
            )); ?>
            <?php submit_button('Cancel and use different account', 'secondary', 'start-over', false, array(
                    'onclick' => 'cancelAndStartOver()',
                    'style' => 'transform:scale(0.9)',
                    'title' => 'Cancel this registration and start over with a different email address or OpenAI key',
            )); ?>
        </div>
        <div class="plugnalai-registered">
            <h2>Activated (<span><?php echo get_option('plugnalai_email');  ?></span>)</h2>
            <h3 id="available-credits">Available credits: <span>--</span></h3>
            <p>This site is registered and you can use Plugna Login AI to customize your login page.</p>
            <?php submit_button('Start Customizing the Login Page', 'primary', 'customize-login-page', false, array(
                'onclick' => 'startCustomizingLoginPage()',
                'title' => 'Go to the login page and start customizing it with Plugna Login AI',
            )); ?>
            <?php submit_button('Deactivate', 'secondary', 'unregister-this-site', false, array(
                'onclick' => 'unregisterSite()',
                'title' => 'Unregister this site from Plugna Login AI. You will need to register again to use Plugna Login AI. Also useful if you want to use a different email address or OpenAI key.',
                'style' => 'transform:scale(0.9);min-width: 165px;'
            )); ?>

            <h2 id="apply-credits">Apply Credits</h2>
            <p>If you have a license key, you can redeem your credits here</p>
            <p>(credits will be added to the email registered with this site - check the email above)</p>
            <table style="margin-left: -4px; width: 100%">
                <tr>
                   <td>
                       <input class="" type="text" placeholder="License key" id="plugnalai-lk" style="width: 100%; margin-right: 6px; max-width: 225px;" />
                       <button id="plugnalai-redeem" onclick="redeemCredits()" class="button button-primary" style="min-width: 150px;">Redeem</button>
                   </td>
                </tr>
            </table>

            <p>If you need more credits, please buy them here first: <a href="https://plugna.com/login-ai/#pricing-table" target="_blank">https://plugna.com/login-ai/#pricing-table</a></p>
        </div>
    </div>
    <style>
        #available-credits {
            border: 1px solid;
            max-width: 207px;
            padding: 8px;
            background: lightgreen;
        }
        h2#apply-credits{
            border-top: 1px solid;
            padding-top: 20px;
            margin-top: 22px;
        }
        #plugna-ai-error {
            opacity: 0;
        }
        #plugna-ai-error.visible {
            opacity: 1;
        }
        #plugna-ai-success {
            opacity: 0;
        }
        #plugna-ai-success.visible {
            opacity: 1;
        }
        #plugna-ai-error th {
            background: #ff9090;
            padding: 4px 7px;
            color: #fff;
        }
        #plugna-ai-success th {
            background: #35cf4b;
            padding: 4px 7px;
            color: #fff;
        }
        body.plugnalai-pending-verification .plugna-wrap form,
        body.plugnalai-registered .plugna-wrap form{
            display: none;
        }
        .plugna-wrap .plugnalai-pending-verification,
        .plugna-wrap .plugnalai-registered{
            display: none;
        }
        body.plugnalai-pending-verification .plugna-wrap .plugnalai-pending-verification,
        body.plugnalai-registered .plugna-wrap .plugnalai-registered{
            display: block;
        }
        /*
        plugna-pending-verification
        */
    </style>
    <script>

        var isValidEmail = function(email) {
            // Email regex pattern
            const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
            // Return true if email matches pattern, false otherwise
            return emailRegex.test(email);
        }

        var startCustomizingLoginPage = function(){
            window.location.href = '<?php echo '/wp-login.php?context=plugna-login-ai'; ?>';
        }

        var redeemCredits = function (){
            var lk = jQuery('#plugnalai-lk').val();

            var $button = jQuery('#plugnalai-redeem');
            $button.attr('disabled', true);

            hidePlugnaAIError();

            jQuery.ajax({
                url: plugnaAilAjax.ajaxurl,
                type: 'POST',
                data: {
                    action: 'plugna_ail_redeem',
                    license_key: lk,
                    nonce: plugnaAilAjax.nonce_redeem,
                },
                success: function(response) {
                    // Handle the successful response
                    console.log(response);
                    if (response.success) {
                        //window.location.reload();
                        //console.log(plugnaAilAjax.success);
                        //console.log(plugnaAilAjax);
                        showPlugnaCreditsAppliedSuccess();
                        jQuery('#available-credits span').text(response.message);
                        console.log(response);
                    } else {
                        showPlugnaAIError(response.message)
                        console.log(response.message);
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    // Handle the error response
                    //alert(plugnaAilAjax.error);
                    console.log(jqXHR, textStatus);
                    //console.log(plugnaAilAjax.error.error);
                },
                complete: function() {
                    // Re-enable the submit button
                    jQuery('#plugnalai-lk').val('');
                    $button.attr('disabled', false);
                }
            });
        }

        var unregisterSite = function(){

            if (confirm('Are you sure you want to unregister this site?')) {
                hidePlugnaAIError();
                var $button = jQuery('#unregister-this-site');
                $button.attr('disabled', true);

                jQuery.ajax({
                    url: plugnaAilAjax.ajaxurl,
                    type: 'POST',
                    data: {
                        action: 'plugna_ail_unregister_site',
                        nonce: plugnaAilAjax.nonce_unregister_site,
                    },
                    success: function(response) {
                        // Handle the successful response
                        console.log(response);
                        if (response.success) {
                            window.location.reload();
                            console.log(plugnaAilAjax.success);
                            console.log(plugnaAilAjax);
                        } else {
                            showPlugnaAIError(response.message)
                            console.log(response.message);
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        // Handle the error response
                        alert(plugnaAilAjax.error);
                        console.log(jqXHR, textStatus);
                        //console.log(plugnaAilAjax.error.error);
                    },
                    complete: function() {
                        // Re-enable the submit button
                        $button.attr('disabled', false);
                    }
                });
            } else {
                // Do nothing!
            }

        }

        var showPlugnaAIError = function(error){
            jQuery('#plugna-ai-error').addClass('visible');
            jQuery('#plugna-ai-error th:first').text('Error: ' + error);
        }
        var hidePlugnaAIError = function (){
            jQuery('#plugna-ai-error').removeClass('visible');
            jQuery('#plugna-ai-error th:first').text('&nbsp;');
            jQuery('#plugna-ai-success').removeClass('visible');
        }

        var showPlugnaSuccess = function (){
            jQuery('#plugna-ai-success').addClass('visible');
            document.body.classList.add('plugnalai-pending-verification');
        }
        var showPlugnaFinalizeSuccess = function (){
            document.body.classList.remove('plugnalai-pending-verification');
            document.body.classList.add('plugnalai-registered');
            var $emailField = jQuery('.plugnalai-registered h2 span');
            if(!$emailField.text()) {
                $emailField.text(jQuery('#plugna-ail-email').val())
            }
        }
        var showPlugnaCreditsAppliedSuccess = function (){
            jQuery('#plugna-ai-success').addClass('visible');
            jQuery('#plugna-ai-success th').text('Credits applied successfully!');
        }
        var showPendingVerification = function (){
            document.body.classList.add('plugnalai-pending-verification');
        }
        var cancelAndStartOver = function (){
            document.body.classList.remove('plugnalai-pending-verification');
        }
        var finalizeRegistration = function (){

            var $button = jQuery('#finalize-registration');
            $button.attr('disabled', true);

            hidePlugnaAIError();

            jQuery.ajax({
                url: plugnaAilAjax.ajaxurl,
                type: 'POST',
                data: {
                    action: 'plugna_ail_finalize_registration',
                    nonce: plugnaAilAjax.nonce_finalize
                },
                success: function(response) {
                    // Handle the successful response
                    console.log(response);
                    if (response.success) {
                        showPlugnaFinalizeSuccess();
                        checkAvailableCredits();
                        //alert(plugnaAilAjax.success);
                        console.log(plugnaAilAjax.success);
                        console.log(plugnaAilAjax);
                    } else {
                        showPlugnaAIError(response.message)
                        console.log(response.message);
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    // Handle the error response
                    alert(plugnaAilAjax.error);
                    console.log(jqXHR, textStatus);
                    //console.log(plugnaAilAjax.error.error);
                },
                complete: function() {
                    // Re-enable the submit button
                    $button.attr('disabled', false);
                }
            });

        }

        const checkAvailableCredits = function(){

            jQuery.ajax({
                url: plugnaAilAjax.ajaxurl,
                type: 'POST',
                data: {
                    action: 'plugna_ail_check_credits',
                    nonce: plugnaAilAjax.nonce_check_credits
                },
                success: function(response) {
                    // Handle the successful response
                    console.log(response);
                    if (response.success) {
                        jQuery('#available-credits span').text(response.message);
                        //showPlugnaFinalizeSuccess();
                        //alert(plugnaAilAjax.success);
                        //console.log(plugnaAilAjax.success);
                        //console.log(plugnaAilAjax);
                    } else {
                        showPlugnaAIError(response.message)
                        //console.log(response.error);
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    // Handle the error response
                    alert(plugnaAilAjax.error);
                    console.log(jqXHR, textStatus);
                    //console.log(plugnaAilAjax.error.error);
                },
                complete: function() {
                    // Re-enable the submit button
                    $button.attr('disabled', false);
                }
            });
        }

        jQuery(document).ready(function($) {
            if(document.body.classList.contains('plugnalai-registered')){
                checkAvailableCredits();
            }
            $('#register-plugin').click(function(e) {
                // Prevent the form from submitting
                e.preventDefault();

                const email = $('#plugna-ail-email').val();
                const openAIKey = $('#plugna-ail-openai-key').val();
                const $button = $('#register-plugin');

                if(email.length < 1) {
                    showPlugnaAIError('Email is required');
                    return;
                }

                if(openAIKey.length < 1) {
                    showPlugnaAIError('Open AI Key is required');
                    return;
                }

                if(openAIKey.length < 10) {
                    showPlugnaAIError('Invalid Open AI Key');
                    return;
                }

                if(!isValidEmail(email)) {
                    showPlugnaAIError('Invalid email');
                    return;
                }
                hidePlugnaAIError();
                // Call the backend endpoint using AJAX
                $button.attr('disabled', true);
                $.ajax({
                    url: plugnaAilAjax.ajaxurl,
                    type: 'POST',
                    data: {
                        action: 'plugna_ail_register',
                        nonce: plugnaAilAjax.nonce,
                        email: email,
                        openai_key: openAIKey
                    },
                    success: function(response) {
                        // Handle the successful response
                        console.log(response);
                        if (response.success) {
                            showPlugnaSuccess();
                            //alert(plugnaAilAjax.success);
                            console.log(plugnaAilAjax.success);
                            console.log(plugnaAilAjax);
                        } else {
                            // if(response.error.indexOf('already registered') !== -1){
                            //     showPlugnaFinalizeSuccess();
                            // } else {
                            //     showPlugnaAIError(response.error)
                            // }
                            showPlugnaAIError(response.message)
                            console.log(response.message);
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        // Handle the error response
                        //alert(plugnaAilAjax.error);
                        console.log(jqXHR, textStatus);
                        //console.log(plugnaAilAjax.error.error);
                    },
                    complete: function() {
                        // Re-enable the submit button
                        $button.attr('disabled', false);
                    }
                });
            });
        });
    </script>
    <script>
        //jQuery(document).ready(function($) {
        //    $('#get-api-key').click(function() {
        //        var email = $('#plugin-email').val();
        //        if (email) {
        //            $.ajax({
        //                url: '<?php //echo admin_url('admin-ajax.php'); ?>//',
        //                type: 'POST',
        //                data: {
        //                    action: 'get_api_key',
        //                    email: email
        //                },
        //                success: function(response) {
        //                    $('#plugin-license-key').val(response).trigger('change');
        //                }
        //            });
        //        }
        //    });
        //
        //    // $('#plugin-license-key').on('change', function() {
        //    //     if ($(this).val()) {
        //    //         $('#register-plugin').prop('disabled', false);
        //    //     } else {
        //    //         $('#register-plugin').prop('disabled', true);
        //    //     }
        //    // });
        //});

    </script>